From 3cc9d80dcb37e359571256af7d5dcbbd4cd903c4 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 3 Feb 2020 20:14:13 +0300
Subject: [PATCH 12/59] Auth helper: WIP on using progress_fd

---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp        | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index aa3dbdae1..4c3bf5458 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -21,9 +21,8 @@
 #include <QProcess>
 #include <QDebug>
 #include <QLoggingCategory>
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonArray>
+#include <QSocketNotifier>
+#include <QScopedPointer>
 #include <QFile>
 
 #include <KAuthHelperSupport>
@@ -134,6 +133,14 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         m_apkdb.setFakeRoot(fakeRoot);
     }
 
+    int progress_fd = m_apkdb.progressFd();
+    qCDebug(LOG_AUTHHELPER) << "    progress_fd: " << progress_fd;
+
+    QScopedPointer<QSocketNotifier> notifier(new QSocketNotifier(progress_fd, QSocketNotifier::Read));
+    QObject::connect(notifier.data(), &QSocketNotifier::activated, notifier.data(), [](int sock) {
+        qCDebug(LOG_AUTHHELPER) << "        read trigger from progress_fd!";
+    });
+
     QtApk::Changeset changes;
     bool upgrade_ok = m_apkdb.upgrade(flags, &changes);
 
-- 
GitLab


